import traceback
from django.utils import timezone


ARBITER_TRANSFER_STEPS = [
    (0, "init_nodes_recs"),
    (1, "sync_ws"),
    (2, "sync_user"),

    (10, "sync_clients"),
    (12, "sync_visitors"),
    (14, "sync_products"),
    (15, "sync_forms"),
    (16, "sync_quickanswers"),
    (18, "sync_orders"),

    (30, "src_power_off"),

    (41, "sync_clients"),
    (42, "sync_visitors"),
    (44, "sync_products"),
    (45, "sync_forms"),
    (46, "sync_quickanswers"),
    (47, "sync_orders"),

    (51, "sync_chats"),
    # (53, "sync_agent_status"),
    (54, "sync_chats"),

    (60, "tgt_power_on"),

    (65, "sync_archive"),
    (66, "sync_statistics"),

    (70, "complete_transfer"),
]


def transfer_execute(trf):
    from apps.balancer.transfer import steps
    tasks = [(_num, _name) for _num, _name in reversed(ARBITER_TRANSFER_STEPS) if _num >= trf.step]

    while len(tasks) > 0:
        _step, tsk = tasks.pop()
        trf.step = _step
        trf.save(update_fields=['step'])
        trf.log(f'Start task {tsk}')
        print(f'Start task {tsk}')
        if callable(getattr(steps, tsk, None)):
            try:
                if not getattr(steps, tsk, None)(trf.pk, trf.website, trf.node_from, trf.node_to, trf.log):
                    trf.log(f'Task {tsk} return non-success result.')
                    print(f'Task {tsk} return non-success result.')
                    return
            except Exception as e:
                err = traceback.format_exc()
                trf.log(f'Task {tsk} crashed {err}')
                print(f'Task {tsk} crashed {err}')
                return        
    if len(tasks) == 0:
        trf.step = 100
        trf.fished = timezone.now()
        trf.save()
        trf.log("Transfer completed")
        print("Transfer completed")
        