from apps.balancer.transfer.utils import apply_sync_data, default_data_writing_call
from nicechat.utils.arbiter_sync import scenario_store
from django.core import serializers


def sync_chats(t_pk, website, node_from, node_to, log):
    return apply_sync_data('sync_chats', t_pk, website, node_from, node_to, log)

def sync_carts(t_pk, website, node_from, node_to, log):
    log('Skiped')
    return True


def do_read_sync_chats(website):
    obj_pack = []

    cli_scenario = {
        'Chat': {
            'clr_fields': ['visitor_id'],
        },
        'Message': {
            'ignore_pk': True,
        },
        'Attachment': {
            'ignore_pk': True,
            'set_fields': {'message': 'Message'}
        }

    }

    from apps.chat.models import Chat

    _recs = []
    for ch in Chat.objects.filter(website=website):
        data = [ch.client, ch]
        for msg in ch.message_set.all():
            data.append(msg)
        for att in ch.attachment_set.all():
            data.append(att)
        _recs.append(serializers.serialize('json', data))

        if len(_recs) > 49:
            if not scenario_store(cli_scenario, _recs, obj_pack, website.pk, 'sync_chats'):
                return False
            _recs = []

    if len(_recs):
        if not scenario_store(cli_scenario,_recs, obj_pack, website.pk, 'sync_chats'):
            return False

    return obj_pack

do_write_sync_chats = default_data_writing_call

