import time

def init_nodes_recs(t_pk, website, node_from, node_to, log):
    from apps.balancer.models import ArbiterNodeWebsite
    ArbiterNodeWebsite.objects.create(
        website=website,
        node=node_to,
        status=ArbiterNodeWebsite.STATUS_PRETARGET
    )
    time.sleep(10)
    return True

def src_power_off(t_pk, website, node_from, node_to, log):
    website.online = False
    website.save()
    from apps.balancer.tasks import sync_website 
    from apps.balancer.models import ArbiterNodeWebsite
    from nicechat.utils.arbiter import update_data_workernode
    an_from = ArbiterNodeWebsite.objects.get(
        website=website,
        node=node_from,
    )
    an_to = ArbiterNodeWebsite.objects.get(
        website=website,
        node=node_to,
    )
    an_from.status = ArbiterNodeWebsite.STATUS_POSTSOURCE
    an_from.save()
    sync_website(website, node_from)
    sync_website(website, node_to)
    update_data_workernode([node_from], 'poweroff', {
        'website_id': website.pk,
        'new_node': an_to.node.name
    })
    return True

def tgt_power_on(t_pk, website, node_from, node_to, log):
    from apps.balancer.models import ArbiterNodeWebsite
    from apps.balancer.tasks import sync_website 
    from nicechat.utils.arbiter import update_data_workernode
    an_to = ArbiterNodeWebsite.objects.get(
        website=website,
        node=node_to,
    )
    update_data_workernode([node_to], 'check_seq', {})

    an_to.status = ArbiterNodeWebsite.STATUS_ACTIVE
    an_to.save()
    website.online = True
    website.save()
    sync_website(website, node_to)
    return True

def complete_transfer(t_pk, website, node_from, node_to, log):
    from apps.balancer.models import ArbiterNodeWebsite
    an_from = ArbiterNodeWebsite.objects.get(
        website=website,
        node=node_from,
    )
    an_from.delete()
    return True
