from apps.balancer.transfer.utils import apply_sync_data, default_data_writing_call
from nicechat.utils.arbiter_sync import scenario_store
from django.core import serializers


def sync_archive(t_pk, website, node_from, node_to, log):
    return apply_sync_data('sync_archive', t_pk, website, node_from, node_to, log)


def sync_statistics(t_pk, website, node_from, node_to, log):
    return apply_sync_data('sync_statistics', t_pk, website, node_from, node_to, log)


def do_read_sync_archive(website):
    obj_pack = []

    cli_scenario = {}

    from apps.chat.models import ArchivedChat

    _data = []
    for cc in ArchivedChat.objects.filter(website=website.pk):
        _data.append(cc)

        if len(_data) > 50:
            if not scenario_store(cli_scenario, [serializers.serialize('json', _data)], obj_pack, website.pk, 'sync_archive'):
                return False
            _data = []

    if len(_data):
        if not scenario_store(cli_scenario, [serializers.serialize('json', _data)], obj_pack, website.pk, 'sync_archive'):
            return False
        _data = []

    return obj_pack


def do_read_sync_statistics(website):
    obj_pack = []

    cli_scenario = {
        'Statistics': {
            'ignore_error': True,
        },
        'VisitorStatWide': {
            'ignore_pk': True,
        },
    }

    from apps.chat.models import VisitorStatWide
    from apps.visitors.models import Statistics

    _data = []
    for cc in VisitorStatWide.objects.filter(website=website.pk):
        _data.append(cc)
        if len(_data) > 500:
            if not scenario_store(cli_scenario, [serializers.serialize('json', _data)], obj_pack, website.pk, 'sync_statistics'):
                return False
            _data = []

    for cc in Statistics.objects.filter(website=website.pk):
        _data.append(cc)
        if len(_data) > 500:
            if not scenario_store(cli_scenario, [serializers.serialize('json', _data)], obj_pack, website.pk, 'sync_statistics'):
                return False
            _data = []

    if len(_data):
        if not scenario_store(cli_scenario, [serializers.serialize('json', _data)], obj_pack, website.pk, 'sync_statistics'):
            return False
        _data = []

    return obj_pack

do_write_sync_statistics = default_data_writing_call
do_write_sync_archive = default_data_writing_call
