from django.dispatch import receiver
from django.db.models.signals import post_save, post_delete
from .models import Plan, CompanyPlan
from nicechat.utils.billing import execute_billing


@receiver(post_save, sender=Plan)
def plan_post_save(sender, instance=None, created=False, **kwargs):
    execute_billing('on_plan_set', args=[instance])


@receiver(post_delete, sender=Plan)
def plan_post_delete(sender, instance=None, **kwargs):
    execute_billing('on_plan_unset', args=[instance])


@receiver(post_save, sender=CompanyPlan)
def website_post_save(sender, instance, created, **kwargs):
    from apps.balancer.tasks import sync_website
    for ws in instance.company.websites.all():
        sync_website(ws)
