# Generated by Django 4.2.1 on 2023-05-20 18:01

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('website', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Chat',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ts_open', models.DateTimeField(auto_now_add=True)),
                ('ts_close', models.DateTimeField(blank=True, db_index=True, null=True)),
                ('sys_ip', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_lang', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_lang_full', models.CharField(blank=True, max_length=100, null=True)),
                ('sys_browser', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_os', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_time', models.IntegerField(default=0)),
                ('sys_info', models.TextField(blank=True, null=True)),
                ('page_ref', models.CharField(default='', max_length=200)),
                ('page_utm', models.JSONField(default=dict)),
                ('geo_country', models.CharField(blank=True, max_length=30, null=True)),
                ('geo_city', models.CharField(blank=True, max_length=100, null=True)),
                ('geo_lat', models.FloatField(default=-90)),
                ('geo_lon', models.FloatField(default=-180)),
                ('obj_props', models.JSONField(default=dict)),
                ('tags', models.CharField(db_index=True, default='', max_length=980)),
                ('is_open', models.BooleanField(default=True)),
                ('is_serialized', models.BooleanField(db_index=True, default=False)),
                ('result_score', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('result_description', models.TextField(blank=True, null=True)),
                ('of_client_score', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('of_client_description', models.TextField(blank=True, null=True)),
                ('result_purchase', models.CharField(blank=True, max_length=100, null=True)),
                ('invited_by_agent', models.PositiveIntegerField(blank=True, null=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Idempotency',
            fields=[
                ('value', models.CharField(max_length=100, primary_key=True, serialize=False)),
                ('mode', models.IntegerField(choices=[(1, 'Guest-based chat'), (2, 'Private P2P'), (3, 'Group room')], db_index=True, default=1)),
            ],
        ),
        migrations.CreateModel(
            name='Visitor',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ts_open', models.DateTimeField(auto_now_add=True)),
                ('ts_close', models.DateTimeField(blank=True, db_index=True, null=True)),
                ('sys_ip', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_lang', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_lang_full', models.CharField(blank=True, max_length=100, null=True)),
                ('sys_browser', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_os', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_time', models.IntegerField(default=0)),
                ('sys_info', models.TextField(blank=True, null=True)),
                ('page_ref', models.CharField(default='', max_length=200)),
                ('page_utm', models.JSONField(default=dict)),
                ('geo_country', models.CharField(blank=True, max_length=30, null=True)),
                ('geo_city', models.CharField(blank=True, max_length=100, null=True)),
                ('geo_lat', models.FloatField(default=-90)),
                ('geo_lon', models.FloatField(default=-180)),
                ('obj_props', models.JSONField(default=dict)),
                ('tags', models.CharField(db_index=True, default='', max_length=980)),
                ('invite_sent', models.DateTimeField(blank=True, null=True)),
                ('invite_discard', models.DateTimeField(blank=True, null=True)),
                ('state', models.CharField(choices=[('online', 'ON-line'), ('offline', 'OFF-line'), ('calling', 'CALLing'), ('chating', 'CHATing')], default='offline', max_length=10)),
                ('page_url', models.CharField(default='', max_length=200)),
                ('page_title', models.CharField(default=' - ', max_length=200)),
                ('session', models.CharField(blank=True, max_length=100, null=True)),
                ('client', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='chat.idempotency')),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='VisitedPage',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('page_url', models.CharField(default='', max_length=200)),
                ('page_title', models.CharField(default=' - ', max_length=200)),
                ('opened_at', models.DateTimeField(auto_now_add=True)),
                ('visitor', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='visited_pages', to='chat.visitor')),
            ],
        ),
        migrations.CreateModel(
            name='Message',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('sender_id', models.CharField(blank=True, max_length=60, null=True)),
                ('sender_name', models.CharField(blank=True, max_length=60, null=True)),
                ('timestamp', models.DateTimeField(auto_now=True)),
                ('text', models.TextField()),
                ('data', models.TextField(blank=True, null=True)),
                ('hidden', models.TextField(blank=True, null=True)),
                ('data_type', models.CharField(blank=True, choices=[('suggest', 'Suggest sent'), ('d_suggst', 'Suggest complete (order created)'), ('c_suggst', 'Suggest canceled'), ('attach', 'Attach sent'), ('form', 'Form sent'), ('f_done', 'Form filled'), ('f_cancel', 'Form canceled'), ('p_viewed', 'Product viewed'), ('p_buy', 'Product want to buy'), ('f_filled', 'Filled form data')], default=None, max_length=8, null=True)),
                ('state', models.SmallIntegerField(choices=[(0, 'New'), (1, 'Sent'), (2, 'Delivered'), (3, 'Was read')], default=1)),
                ('type', models.CharField(choices=[('cli', 'Client'), ('empl', 'Operator'), ('tech', 'Tech-info'), ('evtc', 'Event (for client)'), ('evta', 'Event (for operator)')], db_index=True, default='cli', max_length=5)),
                ('chat', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='chat.chat')),
            ],
        ),
        migrations.CreateModel(
            name='ChatReadStack',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('client_id', models.CharField(blank=True, db_index=True, max_length=100, null=True)),
                ('chat_top_msg_id', models.IntegerField(blank=True, null=True)),
                ('user_top_msg_id', models.IntegerField(blank=True, null=True)),
                ('chat_msg_count', models.IntegerField(default=0)),
                ('user_msg_read', models.IntegerField(default=0)),
                ('unread_count', models.IntegerField(db_index=True, default=0)),
                ('user_msg_notify_id', models.IntegerField(default=0)),
                ('user_msg_notify_cnt', models.IntegerField(default=0)),
                ('user_msg_notify_ts', models.BigIntegerField(default=0)),
                ('chat', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='read_stack', to='chat.chat')),
                ('operator', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='read_stack', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.AddField(
            model_name='chat',
            name='client',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='chat.idempotency'),
        ),
        migrations.AddField(
            model_name='chat',
            name='operators_current',
            field=models.ManyToManyField(blank=True, related_name='operators_current', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='chat',
            name='operators_history',
            field=models.ManyToManyField(blank=True, related_name='operators_history', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='chat',
            name='visitor',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='active_chat', to='chat.visitor'),
        ),
        migrations.AddField(
            model_name='chat',
            name='website',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website'),
        ),
        migrations.CreateModel(
            name='Attachment',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('file_type', models.CharField(blank=True, max_length=100, null=True)),
                ('upload_ts', models.DateTimeField(auto_now=True)),
                ('size', models.IntegerField(blank=True, null=True)),
                ('url', models.URLField()),
                ('chat', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='chat.chat')),
                ('message', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='chat.message')),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
        ),
        migrations.CreateModel(
            name='ArchivedChat',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ts_open', models.DateTimeField(auto_now_add=True)),
                ('ts_close', models.DateTimeField(blank=True, db_index=True, null=True)),
                ('sys_ip', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_lang', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_lang_full', models.CharField(blank=True, max_length=100, null=True)),
                ('sys_browser', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_os', models.CharField(blank=True, max_length=30, null=True)),
                ('sys_time', models.IntegerField(default=0)),
                ('sys_info', models.TextField(blank=True, null=True)),
                ('page_ref', models.CharField(default='', max_length=200)),
                ('page_utm', models.JSONField(default=dict)),
                ('geo_country', models.CharField(blank=True, max_length=30, null=True)),
                ('geo_city', models.CharField(blank=True, max_length=100, null=True)),
                ('geo_lat', models.FloatField(default=-90)),
                ('geo_lon', models.FloatField(default=-180)),
                ('obj_props', models.JSONField(default=dict)),
                ('tags', models.CharField(db_index=True, default='', max_length=980)),
                ('client_name', models.CharField(blank=True, max_length=100, null=True)),
                ('name', models.CharField(max_length=60)),
                ('result_score', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('result_description', models.TextField(blank=True, null=True)),
                ('of_client_score', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('of_client_description', models.TextField(blank=True, null=True)),
                ('result_purchase', models.CharField(blank=True, max_length=100, null=True)),
                ('operators_count', models.PositiveIntegerField(db_index=True, default=0)),
                ('messages', models.TextField(default='{}')),
                ('attachments', models.TextField(default='[]')),
                ('ts_clean_attachments', models.DateTimeField(blank=True, db_index=True, null=True)),
                ('invited_by_agent', models.PositiveIntegerField(blank=True, null=True)),
                ('client', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='chat.idempotency')),
                ('operators', models.ManyToManyField(blank=True, related_name='archived_operators_history', to=settings.AUTH_USER_MODEL)),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
            options={
                'ordering': ('-id',),
            },
        ),
        migrations.CreateModel(
            name='IdempotencyPeer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('peer', models.CharField(db_index=True, max_length=100)),
                ('name', models.CharField(default='Guest', max_length=100)),
                ('info', models.CharField(default='{}', max_length=1024)),
                ('node', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='peers', to='chat.idempotency')),
            ],
            options={
                'unique_together': {('node', 'peer')},
            },
        ),
        migrations.CreateModel(
            name='ChatOuterReplyKeys',
            fields=[
                ('key', models.CharField(max_length=64, primary_key=True, serialize=False)),
                ('chat', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='reply_keys', to='chat.chat')),
                ('operator', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='reply_keys', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'unique_together': {('chat', 'operator')},
            },
        ),
    ]
