# Generated by Django 4.2.1 on 2023-09-25 07:27

from django.db import migrations, models
import django.db.models.deletion


def forwards_func(apps, schema_editor):
    # We get the model from the versioned app registry;
    # if we directly import it, it'll be the wrong version
    Connector = apps.get_model("chat", "Connector")
    db_alias = schema_editor.connection.alias
    Connector.objects.using(db_alias).create(
        name="nicechat", id=0
    )


def reverse_func(apps, schema_editor):
    pass


class Migration(migrations.Migration):

    dependencies = [
        ('chat', '0003_message_is_synthetic_alter_message_data_type'),
    ]

    operations = [
        migrations.CreateModel(
            name='Connector',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(default='nicechat', max_length=10, unique=True)),
                ('connection_key', models.CharField(default=None, max_length=100, blank=True, null=True)),
            ],
        ),
        migrations.RunPython(forwards_func, reverse_func),
        migrations.AddField(
            model_name='message',
            name='is_processed',
            field=models.BooleanField(default=False),
        ),
        migrations.AddField(
            model_name='chat',
            name='is_connector',
            field=models.BooleanField(default=False, db_index=True),
        ),
        migrations.AddField(
            model_name='chat',
            name='connector_name',
            field=models.CharField(default='', max_length=10),
        ),     
        migrations.AddField(
            model_name='idempotency',
            name='connector',
            field=models.ForeignKey(default=0, on_delete=django.db.models.deletion.PROTECT, to='chat.connector'),
        ),
    ]
