from nicechat.admins import ncadmin
from django.contrib import admin
from django.conf import settings

from apps.connector.models import WebsiteConnectorSettings, WebhookEvent


class WebsiteConnectorSettingsAdmin(admin.ModelAdmin):
    list_display = ('website', 'connector', 'is_active')
    list_filter = ('connector', 'is_active', 'website')

class WebhookEventAdmin(admin.ModelAdmin):
    list_display = ('event_id', 'source', 'timestamp')
    list_filter = ('source', 'timestamp', )


if settings.CONNECTOR_ENABLED:
    ncadmin.register(WebsiteConnectorSettings, WebsiteConnectorSettingsAdmin)
    ncadmin.register(WebhookEvent, WebhookEventAdmin)
