import time
from django.core.management.base import BaseCommand
from django.conf import settings
from apps.connector.client import ConnectorLibBase


class Command(BaseCommand):
    help = 'Connector example'

    def add_arguments(self, parser):
        parser.add_argument('site_id', nargs=1, type=int)
        parser.add_argument('--key',  nargs=1, required=False, type=str)

    def handle(self, *args, **options):
        site_id = options.get('site_id').pop()
        key = options.get('key')
        key = key.pop() if key else None

        class ConnectorLib(ConnectorLibBase):

            def on_send_message(self, room_id, event_id, text, sender_name):
                print('TXT', room_id, event_id, text, sender_name)
                self.commit(event_id)

            def on_agent_join(self, room_id, event_id, agent_name, agent_img):
                print('J',room_id, event_id, agent_name, agent_img)
                self.commit(event_id)

            def on_agent_leave(self, room_id, event_id, agent_name):
                print('L',room_id, event_id, agent_name)
                self.commit(event_id)
                
            def on_connect(self):
                self.new_chat_room('room-1', client_name='Guest-1')
                time.sleep(5)
                self.receive_message('room-1', 'Text', client_name='Guest-1')

        ConnectorLib(settings.BOT_HOST, site_id, connector='example', key=key).run()

    if __name__ == "__main__":
        handle()
