from django.conf import settings

from asyncio import Queue
from .bot import Bot
from .connector import ConnectorLib

CONNECTOR_NAME = 'tg'


def run_instance(site_id, tg_key, node_id, nicechat_key=None):
    print("Start bot for site ID", site_id)
    cmd_stream = Queue()
    recv_stream = Queue()

    connector = ConnectorLib(settings.BOT_HOST, site_id, connector=CONNECTOR_NAME, key=nicechat_key, cmd_stream=cmd_stream, recv_stream=recv_stream, node_id=node_id)
    bot = Bot(tg_key, cmd_stream=cmd_stream, recv_stream=recv_stream, connector=connector)
    bot.run()

    print("Stop bot for site ID", site_id)
    exit()
