import urllib.parse

from django.conf import settings

from rest_framework import serializers
from requests_oauthlib import OAuth2Session
from requests_oauthlib.compliance_fixes import facebook_compliance_fix
import google_auth_oauthlib.flow

from apps.connector.models import WebsiteConnectorSettings


class WebsiteConnectorSettingsSerializer(serializers.ModelSerializer):

    class Meta:
        model = WebsiteConnectorSettings
        fields = ('is_active', )

    def update(self, instance, validated_data):
        data = instance.data
        new_data = validated_data.pop('data', {})
        data.update(new_data)

        instance = super().update(instance, validated_data)
        instance.data = data
        instance.save()
        return instance
