from cryptography.hazmat.primitives.ciphers import Cipher, algorithms, modes
import base64
import random
import json
import requests

EXT_MESSAGE_DATA_TYPE_ANSWERS_REPLY = 'ansrpl'
EXT_MESSAGE_DATA_TYPE_ATTACH = 'attach'


key = int(45328).to_bytes(2, 'little') + int(7243).to_bytes(2, 'little')  + int(54372).to_bytes(2, 'little') + int(19676).to_bytes(2, 'little')  
algorithm = algorithms.ARC4(key)
cipher = Cipher(algorithm, mode=None)

def make_state(int_val):
    try:
        encryptor = cipher.encryptor()
        val = random.randint(0,65535).to_bytes(2, 'little') + \
            int_val.to_bytes(6, 'big') + \
            random.randint(0,65535).to_bytes(2, 'little')
        return base64.b32encode(encryptor.update(val)).decode()
    except Exception:
        return None

def get_val_from_state(state):
    try:
        decryptor = cipher.decryptor()
        h = base64.b32decode(state.encode())
        val = decryptor.update(h)
        return int.from_bytes(val[2:8], 'big')
    except Exception:
        return None

def make_message_body(text, client_name, reply_cmd=None, reply_event=None):
    opts = {
        "text": text, 
        "sender_name": client_name
    }
    if reply_cmd and reply_event:
        opts['data_type'] = EXT_MESSAGE_DATA_TYPE_ANSWERS_REPLY
        opts['data'] = json.dumps({"close_ans": reply_event, "BUTTON": reply_cmd})
    return opts


def make_attachment_message(attachment, client_name):
    url = attachment['payload']['url']
    response = requests.head(url)
    opts = {
        "text": "",
        "sender_name": client_name,
        'data_type': EXT_MESSAGE_DATA_TYPE_ATTACH,
        "data": json.dumps({
            "file_type": response.headers["Content-Type"],
            "preview": url,
            "size": int(response.headers["Content-Length"])
        })
    }
    return opts