import sys

from django.core.management.base import BaseCommand

from apps.chat.models import Chat, ArchivedChat
from apps.fts.utils import store_archived_chat, store_active_chat


class Command(BaseCommand):
    help = 'Recreate all fts records'

    def handle(self, *args, **options):
        print('Archives')
        for achat in ArchivedChat.objects.all():
            store_archived_chat(achat)
            sys.stdout.write('.')
            sys.stdout.flush()
        print('done')

        print('Active')
        for chat in Chat.objects.all():
            store_active_chat(chat)
            sys.stdout.write('.')
            sys.stdout.flush()
        print('done')


    if __name__ == "__main__":
        handle()
