from django.conf import settings
from django.db import models


class Search(models.Model):
    SEARCH_TYPE_CHAT=1
    SEARCH_TYPE_ARCHIVE=2
    SEARCH_TYPES_ENUM = (
        (SEARCH_TYPE_CHAT, 'Chat',),
        (SEARCH_TYPE_ARCHIVE, 'Archive',),
    )
    obj_type = models.IntegerField(choices=SEARCH_TYPES_ENUM, default=SEARCH_TYPE_CHAT, db_index=True)
    obj_id = models.IntegerField(db_index=True)
    company_id = models.IntegerField(db_index=True)
    label = models.CharField(max_length=64, default='')
    content = models.TextField()

    class Meta:
        unique_together = ('obj_type', 'company_id', 'obj_id',)
