import traceback
from django.conf import settings
from channels.layers import get_channel_layer
channel_layer = get_channel_layer()
from django.utils.module_loading import import_string


EVENT_CLOSE_CHAT = 'close'
EVENT_NEW_CHAT = 'new'
EVENT_MESSAGE = 'msg'
EVENT_CALLBACK = 'callback'

CMD_WAITUSER = True
CMD_CLOSEBOT = 100
CMD_CALLNEXT = 101
CMD_SWITCH_AI = 50
CMD_CLOSECHAT = 150


###################

KNOWN_BOT = {
    _name: import_string(_path) for _name,_path in settings.ALLOWED_BOTS.items()
}

def process_bot_next_step(chat, botname, event_type, event_data):
    return

    if not botname:
        from apps.ncbot.models import BotChat
        for bc in BotChat.objects.filter(chat=chat):
            process_bot_next_step(chat, bc.botname, event_type, event_data)
        return
    
    botchat = chat.joinedbot.filter(botname=botname).first()
    if not botchat:
        return
    
    _event_data = event_data if isinstance(event_data, dict) else {}
    c = 0
    while c < 50:
        c += 1
        bot = KNOWN_BOT.get(botchat.botname)
        if not bot or not chat or not hasattr(bot, 'process_next_step') or not callable(bot.process_next_step):
            botchat.delete()
            return
        try:
            print('A', c, botchat.botname, event_type, _event_data)
            ret = bot.process_next_step(botchat, event_type, _event_data)
        except Exception as e:
            traceback.print_exception(e)
            return
        
        if ret == CMD_CLOSECHAT:
            botchat.delete()
            from apps.visitors.ws_utils.room import chat_ws_close
            chat_ws_close({}, None, {'chat_id': ch.pk}, None)
            return
        
        if ret == CMD_WAITUSER:
            return

        if ret == CMD_CLOSEBOT:
            botchat.delete()
            return

        if ret == CMD_SWITCH_AI:
            if settings.AI_BOT:
                botchat.botname = settings.AI_BOT
                botchat.state = {}
                botchat.save()
                event_type = EVENT_NEW_CHAT
                _event_data = {}
                continue
            else:
                botchat.delete()
                return
    botchat.delete()
    return       
