from django.core.management.base import BaseCommand
from django.conf import settings
from apps.ncbot.client import BotLibBase
import time



class Command(BaseCommand):
    help = 'Bot example'

    def add_arguments(self, parser):
        parser.add_argument('site_id', nargs=1, type=int)

    def handle(self, *args, **options):
        site_id = options.get('site_id').pop()

        class BotLib(BotLibBase):
            def on_receive(self, chat_id, message):
                # clients messages only
                if "data" in message['text']:
                    data={
                        "buttons": {
                            "id1-1": "Button1",
                            "id1-2": "Button2😃💁",
                            "id1-3": "Button 3 text very-very long text very-very long text very-very long text",
                            "id1-4": "Button3_SingleLineVeryLongTextSingleLineVeryLongTextSingleLineVeryLongTextSingleLineVeryLongTextSingleLineVeryLongTextSingleLineVeryLongTextSingleLineVeryLongText"
                        }
                    }
                else:
                    data = None
                if "show" in message['text']:
                    self.show_tooltip(chat_id, "Tool-tip-text", "Tool-tip answer", "command")
                    return
                if "hide" in message['text']:
                    self.hide_tooltip(chat_id)
                    return
                if "form" in message['text']:
                    self.send_form(chat_id, predefined='catch') # catch|greet
                    return
                self.send(chat_id, message['text'], data, bot_props={"mode": "xxx"})

            def on_forms_list(self, data):
                print(data)

            def on_receive_tech(self, chat_id, message):
                # system and other agents messages
                print(chat_id, message)

            def on_new_room(self, chat_id, room):
                print('Start', chat_id, room)
                time.sleep(3)
                self.send_joined(chat_id)
                self.send(chat_id, 'Hello!')
                self.set_session_val(chat_id, "bot_joined", True)
                print('Session', self.get_session(chat_id))
                # self.send_leave(chat_id)
                
            def on_exists_room(self, chat_id, room):
                # on each room update
                print('Update', chat_id, room)
                print('Session', self.get_session(chat_id))
                #     self.get_room(chat_id)

            def on_get_room(self, chat_id, room):
                print('Rooms details', chat_id, room)

            def on_end_room(self, chat_id, room):
                print('End', chat_id, room)

        BotLib(settings.BOT_HOST, site_id, persistent_db_enable=True).run()

    if __name__ == "__main__":
        handle()
