# Generated by Django 4.2.1 on 2024-05-06 14:30

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('website', '0005_website_online'),
        ('chat', '0004_connector_message_is_processed_idempotency_connector'),
        ('company', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='BotChat',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('botname', models.CharField(db_index=True, max_length=30)),
                ('state', models.JSONField(default=dict)),
                ('chat', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='joinedbot', to='chat.chat')),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
            options={
                'unique_together': {('chat', 'botname')},
            },
        ),
        migrations.CreateModel(
            name='AIAgent',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('instructions', models.TextField(default='')),
                ('assistant_id', models.CharField(max_length=100, unique=True)),
                ('state', models.CharField(default='new', max_length=30)),
                ('ready', models.BooleanField(default=False)),
                ('greeting', models.TextField(default='Hello! How can I help you?')),
                ('enabled', models.BooleanField(db_index=True, default=False)),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
        ),
        migrations.CreateModel(
            name='AIPreset',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=100)),
                ('file_id', models.CharField(max_length=100, blank=True)),
                ('qa_mode', models.BooleanField(default=True)),
                ('state', models.CharField(default='new', max_length=30)),
                ('ready', models.BooleanField(default=False)),
                ('filename', models.CharField(default='unknown.txt', max_length=300)),
                ('enabled', models.BooleanField(db_index=True, default=True)),
                ('website', models.ForeignKey(null=True, blank=True, on_delete=django.db.models.deletion.CASCADE, to='website.website')),
                ('company', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='company.company')),
            ],
        ),
        migrations.CreateModel(
            name='AIPresetQA',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('question', models.TextField()),
                ('answer', models.TextField()),
                ('notes', models.CharField(blank=True, default='', max_length=100)),
                ('preset', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ncbot.aipreset')),
            ],
        ),
        migrations.CreateModel(
            name='AIPresetFile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('data', models.BinaryField()),
                ('preset', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='ncbot.aipreset')),
            ],
        ),
        migrations.CreateModel(
            name='AIAgentLog',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('timestamp', models.DateTimeField(auto_now_add=True)),
                ('log', models.TextField()),
                ('agent', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ncbot.aiagent')),
            ],
        ),
        migrations.AddField(
            model_name='aiagent',
            name='presets',
            field=models.ManyToManyField(to='ncbot.aipreset'),
        ),
    ]
