from django.apps import AppConfig
from django.utils.module_loading import import_string


class UsersConfig(AppConfig):
    name = 'apps.users'

    def ready(self):
        from . import signals

        from .models import User

        otp_factor = []

        from django.conf import settings
        for mod in settings.TFA_MODULES:
            otp_factor.append(import_string(mod)())

        from nicechat.tfa import TfaDoLoop

        setattr(User, 'otp_factor', TfaDoLoop(otp_factor))
