# Generated by Django 4.2.1 on 2023-05-20 17:59

import django.contrib.auth.models
from django.db import migrations, models
import django.utils.timezone
import sorl.thumbnail.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='User',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                ('is_superuser', models.BooleanField(default=False, help_text='Designates that this user has all permissions without explicitly assigning them.', verbose_name='superuser status')),
                ('is_staff', models.BooleanField(default=False, help_text='Designates whether the user can log into this admin site.', verbose_name='staff status')),
                ('is_active', models.BooleanField(default=True, help_text='Designates whether this user should be treated as active. Unselect this instead of deleting accounts.', verbose_name='active')),
                ('date_joined', models.DateTimeField(default=django.utils.timezone.now, verbose_name='date joined')),
                ('email', models.EmailField(max_length=254, unique=True, verbose_name='email address')),
                ('first_name', models.CharField(blank=True, max_length=50, verbose_name='first name')),
                ('last_name', models.CharField(blank=True, max_length=50, verbose_name='last name')),
                ('label', models.CharField(blank=True, max_length=100, null=True)),
                ('contacts', models.TextField(blank=True, null=True)),
                ('avatar', sorl.thumbnail.fields.ImageField(blank=True, null=True, upload_to='avatars')),
                ('position', models.CharField(blank=True, default='', max_length=50)),
                ('phone_number', models.CharField(blank=True, default='', max_length=50)),
                ('timezone', models.CharField(blank=True, max_length=50, null=True)),
                ('interface_language', models.CharField(choices=[('en', 'English'), ('ru', 'Russian')], default='en', max_length=2)),
                ('tfa_opts', models.TextField(default='{}')),
            ],
            options={
                'verbose_name': 'user',
                'verbose_name_plural': 'users',
                'abstract': False,
            },
            managers=[
                ('objects', django.contrib.auth.models.UserManager()),
            ],
        ),
        migrations.CreateModel(
            name='Otp',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('module', models.CharField(max_length=16)),
                ('val', models.CharField(max_length=128)),
                ('ts', models.IntegerField(db_index=True)),
            ],
        ),
        migrations.CreateModel(
            name='UserSiteRole',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('role', models.CharField(choices=[('admin', 'Admin'), ('agent', 'Agent')], default='agent', max_length=16)),
            ],
        ),
    ]
