import os
from datetime import datetime
from django.core.management.base import BaseCommand
from apps.visitors.tasks import VISITORS_KEY, VISITORS_LABEL, WEBSITE_KEY, TS_KEY
from django.conf import settings


class Command(BaseCommand):
    help = 'Pack multiple data-files to sing in each 15min range'

    def handle(self, *args, **options):
        tnow = int((datetime.now() - datetime(1970, 1, 1)).total_seconds())

        for filename in os.listdir(settings.STATISTICS_ROOT):

            f_keys = filename.split('-')

            if f_keys[VISITORS_KEY] == VISITORS_LABEL and filename.endswith(".txt"):

                filenm = os.path.join(settings.STATISTICS_ROOT, filename)
                try:
                    mtime = os.path.getmtime(filenm)
                except OSError:
                    mtime = 0
                if tnow - mtime < settings.STATISTICS_ROTATE_INTERVAL * 1.5:
                    continue

                try:
                    ts = int(float(f_keys[TS_KEY]))
                except ValueError:
                    continue

                ts_d = int(int(ts)/settings.STATISTICS_ROTATE_INTERVAL) * settings.STATISTICS_ROTATE_INTERVAL

                try:
                    with open(filenm, 'r') as f:
                        data = f.read() #.split('\n')
                except (OSError, IOError):
                    continue

                os.rename(filenm, "%s.%s.%s" % (filenm, tnow, 'bak'))
                d_file = os.path.join(settings.STATISTICS_ROOT, "%s-%s-%s.0-.txt" % (VISITORS_LABEL, f_keys[WEBSITE_KEY], ts_d))
                with open(d_file, 'a+') as f:
                    f.write(data)
                    f.close()

                print(ts, " >> ", ts_d)

    if __name__ == "__main__":
        handle()
