from django.core.management.base import BaseCommand
from apps.visitors.tasks import statistics_aggregating, Statistics, DAY, HOUR, MONTH, WEEK


class Command(BaseCommand):
    help = 'Run Celery.statistics_aggregating immediately'

    def add_arguments(self, parser):
        parser.add_argument('action', default=None, choices=['daily', 'hourly', 'weekly', 'monthly'])

    def handle(self, *args, **options):
        action = options.get('action', None)

        if action == 'hourly':
            statistics_aggregating(Statistics.QUARTER, Statistics.HOUR, HOUR, False)
        elif action == 'daily':
            statistics_aggregating(Statistics.HOUR, Statistics.DAY, DAY, False)
        elif action == 'weekly':
            statistics_aggregating(Statistics.DAY, Statistics.WEEK, WEEK, False)
        elif action == 'monthly':
            statistics_aggregating(Statistics.DAY, Statistics.MONTH, MONTH, False)
        else:
            pass

    if __name__ == "__main__":
        handle()
