# Generated by Django 4.2.1 on 2023-05-20 17:59

from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Browser',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=25)),
                ('type', models.CharField(choices=[('m', 'mobile'), ('d', 'desktop')], default='d', max_length=1)),
                ('icon', models.ImageField(blank=True, null=True, upload_to='')),
            ],
        ),
        migrations.CreateModel(
            name='Client',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('client_id', models.CharField(db_index=True, max_length=100)),
                ('client_name', models.CharField(blank=True, max_length=100, null=True)),
                ('first_ts', models.DateTimeField(auto_now_add=True)),
                ('last_activity_ts', models.DateTimeField(auto_now_add=True)),
                ('visit_count', models.IntegerField(default=0)),
                ('chat_count', models.IntegerField(default=0)),
                ('void_chat_count', models.IntegerField(default=0)),
                ('unaccepted_chat_count', models.IntegerField(default=0)),
                ('purchase_count', models.IntegerField(default=0)),
                ('product_view_count', models.IntegerField(default=0)),
                ('rate_avg', models.FloatField(default=0.0)),
                ('rate_count', models.IntegerField(default=0)),
                ('props', models.JSONField(default=dict)),
                ('cart', models.JSONField(default=dict)),
            ],
        ),
        migrations.CreateModel(
            name='ClientCarts',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ts', models.DateTimeField(blank=True, null=True)),
                ('cart', models.JSONField(default=dict)),
            ],
        ),
        migrations.CreateModel(
            name='ClientEntrance',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ts', models.DateTimeField(blank=True, null=True)),
                ('pages', models.IntegerField(default=0)),
                ('duration', models.IntegerField(default=0)),
            ],
        ),
        migrations.CreateModel(
            name='ClientPromotion',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ts', models.DateTimeField(blank=True, null=True)),
                ('props', models.JSONField(default=dict)),
            ],
        ),
        migrations.CreateModel(
            name='FormResult',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.CharField(max_length=50)),
                ('form_id', models.IntegerField(db_index=True)),
                ('chat_id', models.IntegerField()),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('result', models.JSONField(default=dict)),
            ],
        ),
        migrations.CreateModel(
            name='OperatingSystem',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=25)),
                ('type', models.CharField(choices=[('m', 'mobile'), ('d', 'desktop')], default='d', max_length=1)),
                ('icon', models.ImageField(blank=True, null=True, upload_to='')),
            ],
        ),
        migrations.CreateModel(
            name='Order',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('chat_id', models.IntegerField(blank=True, db_index=True, null=True)),
                ('order_num', models.CharField(db_index=True, default='n/a', max_length=50)),
                ('order_date', models.DateTimeField(auto_now_add=True)),
                ('qty', models.IntegerField(default=1)),
                ('shipping_address', models.JSONField(default=dict)),
                ('billing_address', models.JSONField(default=dict)),
                ('product_detail', models.JSONField(default=dict)),
            ],
        ),
        migrations.CreateModel(
            name='Statistics',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('period', models.CharField(choices=[('q', '15 minutes'), ('h', 'hour'), ('d', 'day'), ('w', 'week'), ('m', 'month')], max_length=1)),
                ('ts', models.DateTimeField()),
                ('visitors_count', models.IntegerField(default=0)),
                ('browsers', models.JSONField(default=dict)),
                ('desktop_os', models.JSONField(default=dict)),
                ('mobile_os', models.JSONField(default=dict)),
                ('cities', models.JSONField(default=dict)),
                ('pages', models.JSONField(default=dict)),
                ('referrers', models.JSONField(default=dict)),
                ('utm_tags', models.JSONField(default=dict)),
                ('aggregated', models.BooleanField(default=False)),
            ],
        ),
    ]
