from django.urls import path, re_path
from .views import MakeWidget, AvatarView, UploadView, UpdateWidgetSession, WidgetLogin

urlpatterns = [
    path('widget.js', MakeWidget.as_view(), name='get_widget'),
    re_path('(?P<direct>[0-9a-zA-Z\.\-]+)/widget.js', MakeWidget.as_view(), name='get_direct_widget'),
    path('update_session/', UpdateWidgetSession.as_view(), name='update_widget'),
    path('login/', WidgetLogin.as_view(), name='login_widget'),
    re_path(r'^avatar-(ca|ce|d)-(?P<user_id>[0-9]+).jpg$', AvatarView.as_view(), name='widget_avatar'),
    re_path(r'^avatar-(?P<site_id>[0-9]+).jpg$', AvatarView.as_view(), name='widget_avatar_site'),
    path('upload/<int:site_id>/<int:chat_id>/', UploadView.as_view(), name='widget_upload_to_chat'),
    path('upload/<int:site_id>/', UploadView.as_view(), name='widget_upload_init_chat'),
]

