from nicechat.admins import ncadmin
from django.contrib import admin

from ..website.models import Website, AccessToken, QuickReply, \
    ProductsCategory, Product, FormRow, Form, AgentStatus, Status, WidgetSettings, WidgetTheme


class QuickReplyAdmin(admin.ModelAdmin):
    list_display = ('website', 'is_private', 'text',)
    list_filter = ('is_private',)


class FormRowAdminInline(admin.TabularInline):
    model = FormRow


class FormAdmin(admin.ModelAdmin):
    list_display = ('label', 'pk', 'website', 'company', 'is_enabled')
    inlines = [
        FormRowAdminInline,
    ]

    def get_queryset(self, request):
        return super(FormAdmin, self).get_queryset(request).exclude(access_write=Form.PERM_WRITE_SUPER)


ncadmin.register(Website)
ncadmin.register(AccessToken)
ncadmin.register(ProductsCategory)
ncadmin.register(Product)
ncadmin.register(Status)
ncadmin.register(Form, FormAdmin)
ncadmin.register(QuickReply, QuickReplyAdmin)
ncadmin.register(AgentStatus)
ncadmin.register(WidgetSettings)
ncadmin.register(WidgetTheme)
