from django.core.management import BaseCommand
from apps.website.models import WidgetTheme, Website
from apps.website.utils.service import check_website_settings


class Command(BaseCommand):
    help = 'Check is the website settings available'

    def handle(self, *args, **options):
        check_themes()
        check_settings()

    if __name__ == "__main__":
        handle()


WIDGET_THEMES = ['eae9d5', 'd4ecd8', 'cacce8', 'cad8e8', 'e3d0e8', 'e9e9ee', '1d242b', '394868', '4fbdae', 'cd6060']


def check_themes():
    for theme in WIDGET_THEMES:
        if not WidgetTheme.objects.filter(name=theme).first():
            WidgetTheme.objects.create(name=theme)
            print("Create theme", theme)


def check_settings():
    for website in Website.objects.all():
        check_website_settings(website)
