# Generated by Django 4.2.1 on 2023-05-20 17:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('company', '0001_initial'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Form',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('access_write', models.IntegerField(choices=[(2, 'Can be written by agent and admin'), (1, 'Can be written by admin'), (0, 'Can be written by superuser')], db_index=True, default=2)),
                ('access_read', models.IntegerField(choices=[(0, 'Public. But, not shown in list (choice by ID)'), (1, 'Company. Visible for all sites of company.'), (2, 'Website. Visible to specified site only'), (3, 'Private. Visible only to the author')], db_index=True, default=3)),
                ('is_enabled', models.BooleanField(default=False)),
                ('label', models.CharField(max_length=50)),
                ('mode', models.CharField(choices=[('regular', 'Regular form'), ('purchase', 'Purchase form'), ('catch', 'Catch form'), ('greet', 'Greeting form')], db_index=True, default='regular', max_length=10)),
                ('company', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='company.company')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Website',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(db_index=True, max_length=100)),
                ('domain', models.CharField(max_length=512, unique=True)),
                ('icon', models.ImageField(blank=True, null=True, upload_to='website-icons')),
                ('cart_callback', models.CharField(blank=True, max_length=512, null=True)),
                ('props', models.JSONField(default=dict)),
                ('company', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='websites', to='company.company')),
                ('users', models.ManyToManyField(blank=True, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='WidgetTheme',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=50)),
                ('icon_img', models.ImageField(blank=True, null=True, upload_to='widget-themes')),
            ],
        ),
        migrations.CreateModel(
            name='WidgetSettings',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('position', models.CharField(choices=[('left', 'Left'), ('right', 'Right')], default='right', max_length=5)),
                ('shape', models.CharField(choices=[('round', 'Round'), ('square', 'Square'), ('rounded_square', 'Rounded square'), ('rectangle', 'Rectangle'), ('rounded_rectangle', 'Rounded rectangle')], default='rounded_rectangle', max_length=17)),
                ('size', models.CharField(choices=[('s', 'Small'), ('m', 'Medium'), ('l', 'Large')], default='m', max_length=2)),
                ('icon_img', models.ImageField(blank=True, null=True, upload_to='widget-icons')),
                ('agent_avatar', models.BooleanField(default=False)),
                ('text_shape_label', models.CharField(blank=True, max_length=50, null=True)),
                ('text_title', models.CharField(blank=True, max_length=50, null=True)),
                ('theme', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.widgettheme')),
                ('website', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
        ),
        migrations.CreateModel(
            name='Status',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('server_code', models.IntegerField()),
                ('widget_installed', models.BooleanField(default=False)),
                ('allow_site_access', models.BooleanField(default=False)),
                ('partner_id', models.CharField(blank=True, max_length=64, null=True)),
                ('timestamp', models.DateTimeField(auto_now=True)),
                ('website', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
            options={
                'verbose_name_plural': 'statuses',
            },
        ),
        migrations.CreateModel(
            name='QuickReply',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_private', models.BooleanField(default=False)),
                ('text', models.TextField()),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
        ),
        migrations.CreateModel(
            name='ProductsCategory',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('original_id', models.CharField(max_length=64)),
                ('is_enabled', models.BooleanField(default=True)),
                ('version', models.CharField(blank=True, max_length=128, null=True)),
                ('parent', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='website.productscategory')),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
            options={
                'unique_together': {('website', 'original_id')},
            },
        ),
        migrations.CreateModel(
            name='FormRow',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('kind', models.CharField(choices=[('text', 'Input text'), ('email', 'Input Email'), ('number', 'Input number'), ('textarea', 'Textarea'), ('checkbox', 'Checkbox'), ('radio', 'Radio choice'), ('choice', 'Dropdown choice'), ('multicheckbox', 'Multiple selection list'), ('hidden', 'Hidden'), ('country', 'Country (dropdown)'), ('state', 'State of USA'), ('label', 'Label (text)'), ('group', 'Group begin'), ('address', 'Address (block)')], max_length=15)),
                ('label', models.CharField(max_length=50)),
                ('description', models.TextField(blank=True, null=True)),
                ('is_read_only', models.BooleanField(default=False)),
                ('is_required', models.BooleanField(default=False)),
                ('protected', models.BooleanField(default=False)),
                ('order_num', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('params', models.TextField(default='{}')),
                ('form', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.form')),
            ],
        ),
        migrations.AddField(
            model_name='form',
            name='website',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='website.website'),
        ),
        migrations.CreateModel(
            name='Callbacks',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('event', models.CharField(db_index=True, max_length=20)),
                ('target', models.CharField(choices=[('t_email', 'E-mail (JSON-data)'), ('h_email', 'E-mail (human-like data'), ('slack', 'Slack'), ('http', 'HTTP')], max_length=8)),
                ('is_active', models.BooleanField(db_index=True, default=True)),
                ('params', models.JSONField(default=dict)),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
        ),
        migrations.CreateModel(
            name='AgentStatus',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_active', models.BooleanField(db_index=True, default=False)),
                ('state', models.CharField(choices=[('online', 'ON-Line'), ('busy', 'Busy'), ('away', 'Away')], default='away', max_length=8)),
                ('operator', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='agent_status', to=settings.AUTH_USER_MODEL)),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
        ),
        migrations.CreateModel(
            name='AccessToken',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('token', models.CharField(max_length=50, unique=True)),
                ('description', models.CharField(blank=True, max_length=255, null=True)),
                ('secret', models.CharField(max_length=50)),
                ('gen_timestamp', models.DateTimeField(blank=True, null=True)),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
        ),
        migrations.CreateModel(
            name='Product',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('original_id', models.CharField(max_length=64)),
                ('title', models.CharField(max_length=100)),
                ('price', models.DecimalField(blank=True, decimal_places=2, max_digits=15, null=True)),
                ('currency', models.CharField(blank=True, choices=[('usd', 'USD'), ('cad', 'CAD'), ('gbp', 'GBP'), ('aud', 'AUD'), ('uah', 'UAH'), ('aed', 'AED'), ('afn', 'AFN'), ('all', 'ALL'), ('amd', 'AMD'), ('ang', 'ANG'), ('aoa', 'AOA'), ('ars', 'ARS'), ('awg', 'AWG'), ('azn', 'AZN'), ('bam', 'BAM'), ('bbd', 'BBD'), ('bdt', 'BDT'), ('bgn', 'BGN'), ('bhd', 'BHD'), ('bif', 'BIF'), ('bmd', 'BMD'), ('bnd', 'BND'), ('bob', 'BOB'), ('bov', 'BOV'), ('brl', 'BRL'), ('bsd', 'BSD'), ('btn', 'BTN'), ('bwp', 'BWP'), ('byr', 'BYR'), ('bzd', 'BZD'), ('cdf', 'CDF'), ('che', 'CHE'), ('chf', 'CHF'), ('chw', 'CHW'), ('clf', 'CLF'), ('clp', 'CLP'), ('cny', 'CNY'), ('cop', 'COP'), ('cou', 'COU'), ('crc', 'CRC'), ('cuc', 'CUC'), ('cup', 'CUP'), ('cve', 'CVE'), ('czk', 'CZK'), ('djf', 'DJF'), ('dkk', 'DKK'), ('dop', 'DOP'), ('dzd', 'DZD'), ('eek', 'EEK'), ('egp', 'EGP'), ('ern', 'ERN'), ('etb', 'ETB'), ('eur', 'EUR'), ('fjd', 'FJD'), ('fkp', 'FKP'), ('gel', 'GEL'), ('ghs', 'GHS'), ('gip', 'GIP'), ('gmd', 'GMD'), ('gnf', 'GNF'), ('gtq', 'GTQ'), ('gyd', 'GYD'), ('hkd', 'HKD'), ('hnl', 'HNL'), ('hrk', 'HRK'), ('htg', 'HTG'), ('huf', 'HUF'), ('idr', 'IDR'), ('ils', 'ILS'), ('inr', 'INR'), ('iqd', 'IQD'), ('irr', 'IRR'), ('isk', 'ISK'), ('jmd', 'JMD'), ('jod', 'JOD'), ('jep', 'JEP'), ('jpy', 'JPY'), ('kes', 'KES'), ('kgs', 'KGS'), ('khr', 'KHR'), ('kmf', 'KMF'), ('kpw', 'KPW'), ('krw', 'KRW'), ('kwd', 'KWD'), ('kyd', 'KYD'), ('kzt', 'KZT'), ('lak', 'LAK'), ('lbp', 'LBP'), ('lkr', 'LKR'), ('lrd', 'LRD'), ('lsl', 'LSL'), ('ltl', 'LTL'), ('lvl', 'LVL'), ('lyd', 'LYD'), ('mad', 'MAD'), ('mdl', 'MDL'), ('mga', 'MGA'), ('mkd', 'MKD'), ('mmk', 'MMK'), ('mnt', 'MNT'), ('mop', 'MOP'), ('mro', 'MRO'), ('mur', 'MUR'), ('mvr', 'MVR'), ('mwk', 'MWK'), ('mxn', 'MXN'), ('mxv', 'MXV'), ('myr', 'MYR'), ('mzn', 'MZN'), ('nad', 'NAD'), ('ngn', 'NGN'), ('nio', 'NIO'), ('nok', 'NOK'), ('npr', 'NPR'), ('nzd', 'NZD'), ('omr', 'OMR'), ('pab', 'PAB'), ('pen', 'PEN'), ('pgk', 'PGK'), ('php', 'PHP'), ('pkr', 'PKR'), ('pln', 'PLN'), ('pyg', 'PYG'), ('qar', 'QAR'), ('ron', 'RON'), ('rsd', 'RSD'), ('rub', 'RUB'), ('rwf', 'RWF'), ('sar', 'SAR'), ('sbd', 'SBD'), ('scr', 'SCR'), ('sdg', 'SDG'), ('sek', 'SEK'), ('sgd', 'SGD'), ('shp', 'SHP'), ('sll', 'SLL'), ('sos', 'SOS'), ('srd', 'SRD'), ('ssp', 'SSP'), ('std', 'STD'), ('svc', 'SVC'), ('syp', 'SYP'), ('szl', 'SZL'), ('thb', 'THB'), ('tjs', 'TJS'), ('tmt', 'TMT'), ('tnd', 'TND'), ('top', 'TOP'), ('try', 'TRY'), ('ttd', 'TTD'), ('twd', 'TWD'), ('tzs', 'TZS'), ('ugx', 'UGX'), ('usn', 'USN'), ('uss', 'USS'), ('uyi', 'UYI'), ('uyu', 'UYU'), ('uzs', 'UZS'), ('vef', 'VEF'), ('vnd', 'VND'), ('vuv', 'VUV'), ('wst', 'WST'), ('xaf', 'XAF'), ('xag', 'XAG'), ('xau', 'XAU'), ('xba', 'XBA'), ('xbb', 'XBB'), ('xbc', 'XBC'), ('xbd', 'XBD'), ('xcd', 'XCD'), ('xdr', 'XDR'), ('xof', 'XOF'), ('xpd', 'XPD'), ('xpf', 'XPF'), ('xpt', 'XPT'), ('xsu', 'XSU'), ('xts', 'XTS'), ('xua', 'XUA'), ('xxx', 'XXX'), ('yer', 'YER'), ('zar', 'ZAR'), ('zmw', 'ZMW'), ('zwl', 'ZWL')], default='usd', max_length=5, null=True)),
                ('description', models.TextField(blank=True, null=True)),
                ('url', models.CharField(blank=True, max_length=512, null=True)),
                ('image_url', models.CharField(blank=True, max_length=512, null=True)),
                ('in_stock', models.BooleanField(default=False)),
                ('version', models.CharField(blank=True, max_length=128, null=True)),
                ('props', models.JSONField(default=dict)),
                ('category', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='website.productscategory')),
                ('website', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='website.website')),
            ],
            options={
                'ordering': ('-id',),
                'unique_together': {('website', 'original_id')},
            },
        ),
    ]
