from .utils.check_website_status import check_website_status_do
from .utils.parsers import do_process_import
from .utils.form import check_website_forms
from .utils.service import check_website_settings
from .utils.billing import check_payments_status_do
from nicechat.celery import app


@app.task
def check_website_status():
    check_website_status_do()


@app.task
def check_payments_status():
    check_payments_status_do()


@app.task
def process_import(site_id, user, current_site, data, csv=None, google_merchant_csv=None,
                   token=None, callback=None):
    return do_process_import(site_id, user, current_site, data, csv=csv, token=token, callback=callback,
                             google_merchant_csv=google_merchant_csv)


@app.task
def create_website_celery(website_id):
    from .models import Website
    website = Website.objects.filter(pk=website_id).first()
    if website:
        check_website_forms(website)
        check_website_settings(website)


@app.task
def clean_chatrooms():
    from nicechat.utils.periodical_task import clean_chatrooms
    clean_chatrooms(False)


@app.task
def check_room2agent_status():    
    from apps.website.utils.check_website_status import check_room2agent_status_do
    check_room2agent_status_do()
