from apps.website.models import Product, ProductsCategory


def create_or_update_category(name, original_id, website_id):
    ProductsCategory.objects.update_or_create(website_id=website_id,
                                              original_id=original_id,
                                              defaults={'name': name})


def create_or_update_product(title, price, currency, description, url, website_id, image_url, original_id, category_id):
    category = None
    category_q = ProductsCategory.objects.filter(original_id=category_id)
    if len(category_q) > 0:
        category = category_q.first()
    Product.objects.update_or_create(
        website_id=website_id,
        original_id=original_id,
        defaults={'title': title,
                  'price': float(price),
                  'currency': currency,
                  'description': description if description is not None else '',
                  'url': url,
                  'image_url': image_url,
                  'category': category})
