from django.conf import settings
from apps.website.models import WidgetTheme, WidgetSettings


def check_website_settings(website):
    if settings.NODE_MODE == settings.NODE_MODE_WORKER:
        return
    try:
        setting = website.widgetsettings
        return
    except WidgetSettings.DoesNotExist:
        pass

    th = WidgetTheme.objects.first()
    WidgetSettings.objects.create(
        website=website,
        position=settings.DEFAULT_WIDGET_POSITION,
        shape=settings.DEFAULT_WIDGET_SHAPE,
        size=settings.DEFAULT_WIDGET_SIZE,
        theme=th,
        agent_avatar=True
    )


def filter_products_props(dct):
    if isinstance(dct, dict):
        n_dct = {}
        j = 0
        for key, val in dct.items():
            if not isinstance(key, str):
                continue
            if j >= settings.PRODUCTS_PROPS_CHECK_MAX_COUNT:
                break
            if len(key) > settings.PRODUCTS_PROPS_CHECK_KEY_LEN:
                continue
            if (isinstance(val, str) and len(val) > settings.PRODUCTS_PROPS_CHECK_VALUE_LEN) or \
                    isinstance(val, int) or not isinstance(val, float):
                n_dct[key] = val
                j += 1
        return n_dct
    return {}
