import traceback
import json
from django.views.generic import View
from apps.website.models import Website
from apps.balancer.models import ArbiterSetting
from django.http import HttpResponse

# Create your views here.


class HealthCheck(View):
    def get(self, request, *args, **kwargs):
        try:
            if Website.objects.count():
                return HttpResponse("ok", status=200)
            else:
                return HttpResponse("none", status=202)
        except Exception as e:
            traceback.print_exception(e)
            return HttpResponse("err", status=500)


class PropsView(View):
    def get(self, request, *args, **kwargs):
        data = json.dumps({a.key: a.val for a in ArbiterSetting.objects.filter(key__in=['global_title', 'global_domain'])})
        return HttpResponse(
            f"""
                window.NC_BASE_PROPS = '{data}';
            """,
            content_type="application/javascript")