from django.core.management.base import BaseCommand

from billproviders.braintree.customer import create_customers_braintree_accounts
from apps.company.models import Company


class Command(BaseCommand):
    help = 'Creates corresponding Billing customer accounts ' \
           'for those companies in db that have no `billing_id` field set'

    def handle(self, *args, **options):
        companies_num = Company.objects.filter(billing_id__isnull=True).count()
        create_customers_braintree_accounts()

        self.stdout.write(self.style.SUCCESS('Billing accounts creation '
                                             'was applied to {} companies'.format(companies_num)))