from django.core.management.base import BaseCommand

from apps.company.models import Company
from nicechat.utils.billing import execute_billing


class Command(BaseCommand):
    help = 'Synchronizes Braintree customers data'

    def handle(self, *args, **options):
        braintree_companies = Company.objects.filter(billing_id__isnull=False)
        companies_num = len(braintree_companies)

        for company in braintree_companies:
            execute_billing('sync', [company])

        self.stdout.write(self.style.SUCCESS('Braintree accounts sync done for {} companies'.format(companies_num)))
