import braintree

def convert_braintree_status(braintree_status):
    from apps.billing.models import Transaction
    successful_statuses = [braintree.Transaction.Status.Authorized,
                           braintree.Transaction.Status.Settled,
                           braintree.Transaction.Status.SettlementConfirmed]
    pending_statuses = [braintree.Transaction.Status.Authorizing,
                        braintree.Transaction.Status.SettlementPending,
                        braintree.Transaction.Status.Settling,
                        braintree.Transaction.Status.SubmittedForSettlement]
    failed_statuses = [braintree.Transaction.Status.AuthorizationExpired,
                       braintree.Transaction.Status.Failed,
                       braintree.Transaction.Status.GatewayRejected,
                       braintree.Transaction.Status.ProcessorDeclined,
                       braintree.Transaction.Status.SettlementDeclined,
                       braintree.Transaction.Status.SettlementFailed,
                       braintree.Transaction.Status.Voided,
                       braintree.Transaction.Status.Unrecognized]
    status_conversion = {
        Transaction.SUCCESS: successful_statuses,
        Transaction.PENDING: pending_statuses,
        Transaction.FAILED: failed_statuses,
    }

    for (local_status, bt_statuses) in status_conversion.items():
        if braintree_status in bt_statuses:
            return local_status

    return None
