from django.contrib import admin
from django.http import Http404


class NiceChatAdmin(admin.AdminSite):
    def each_context(self, request):
        from apps.users.utils import is_ip_whitelisted
        if not is_ip_whitelisted(request.META):
            raise Http404()
        return super(NiceChatAdmin, self).each_context(request)


ncadmin = NiceChatAdmin(name="NiceChatAdmin")
