import os
import sys
from celery import Celery

os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'nicechat.settings')

from django.conf import settings
from celery.signals import beat_init

app = Celery('nicechat')

app.config_from_object('django.conf:settings')
app.autodiscover_tasks(lambda: settings.INSTALLED_APPS)

redbeat_redis_url = settings.BROKER_URL

@beat_init.connect
def setup_direct_queue(sender, *args, **kwargs):
    if settings.NODE_MODE == settings.NODE_MODE_WORKER:
        from nicechat.utils.arbiter_sync import node_syncing
        print("Celery syncing...")
        node_syncing()
