from django.conf import settings
from rest_framework import serializers


class ImageUrlSerializer(serializers.CharField):

    def to_internal_value(self, data):
        ret = super(ImageUrlSerializer, self).to_internal_value(data)
        if isinstance(ret, str):
            tpl = settings.MEDIA_URL
            if ret.startswith(tpl):
                ret = ret[len(tpl):]
        return ret

    def to_representation(self, instance):
        rez =  super(ImageUrlSerializer, self).to_representation(instance)
        ret = (f'{settings.MEDIA_URL}{rez}') if rez else None
        return ret