from django import template
from django.conf import settings
register = template.Library()

@register.simple_tag
def nc_chat_name():
    return settings.BASE_CHAT_NAME

@register.simple_tag
def nc_domain(name="main"):
    if name == "main":
        return settings.DOMAIN_BASE
    elif name == "account":
        return settings.DOMAIN_ACC
    elif name == "widget":
        return settings.DOMAIN_WGT
    elif name == "cdn":
        return settings.DOMAIN_CDN
    elif name == "support":
        return settings.DOMAIN_SUP
    else:
        return settings.DOMAIN_BASE


@register.simple_tag
def correct_link(link):
    return link

TECH_TR = {
    'LEAVE': '{{}} leave the chat!',
    'JOINED': '{{}} joined the chat!',
    'WELCOME': 'Chat created',
    'CHAT_RENAME': 'Chat renamed',
    'COMPLETE': 'The visitor has completed a chat',
    'CLOSEDBYAGENT': 'The agent has completed the chat.',
    'CLOSEDBYSERVER': 'The chat closed by activity timeout.',
    'ATTBLOCK': 'Attachment %s was blocked by server.'
}

@register.simple_tag
def update_tech(msg=''):
    try:
        if isinstance(msg, str) and msg.startswith('~!'):
            msg = msg[2:]
            args = msg.split(':')
            cmd = args[0]
            args = args[1:]
            msg = TECH_TR.get(cmd, cmd)
            if args and '{{}}' in msg:
                msg = msg.replace('{{}}', args[0])
    except Exception:
        pass
    return msg
