import socket
import ipaddress
import signal
import time
import threading
import os
import sys

stop_loop = False
tasks = {}
known = {}


wsock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
wsock.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)

def exit_gracefully():
    global stop_loop
    stop_loop = True


signal.signal(signal.SIGTERM, exit_gracefully)

def upd_bcproc():
    global stop_loop, tasks, known
    print(f'Start UDP broadcast connector {os.getpid()}', flush=True)

    while not stop_loop:
        if not tasks:
            time.sleep(0.25)
        else:
            try:
                interfaces = socket.getaddrinfo(host=socket.gethostname(), port=None, family=socket.AF_INET)
                allips = list(set([ip[-1][0] for ip in interfaces]))
                for ip in allips:
                    print(ip, flush=True)
                    sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, socket.IPPROTO_UDP)  # UDP
                    sock.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)
                    sock.bind((ip,0))
                    for h in ipaddress.ip_network(f"{ip}/16", strict=False).hosts():
                        for msg, starts in list(tasks.items()):
                            _to = str(h)
                            if starts[0] is None:
                                tasks[msg][0] = _to
                                for _ip, _ts in list(known.items()):
                                    if time.time() - _ts > 120:
                                        del knows[_ip]
                                    else:
                                        sock.sendto(msg, (_ip, 5005))
                                        tasks[msg][1].append(_ip)
                                        # print('QQQQ', _ip)
                            elif starts[0] == _to:
                                del tasks[msg]
                            if _to in starts[1]:
                                continue
                            sock.sendto(msg, (_to, 5005))
                    sock.close()
            except Exception:
                pass
    print(f'Stop UDP broadcast connector {os.getpid()}', flush=True)


def udp_bcserver():   
    global stop_loop 
    print(f'Start UDP broadcast proxy {os.getpid()}', flush=True)
    wsock.bind(("0.0.0.0", 5006))

    t = threading.Thread(target=upd_bcproc)
    t.setDaemon(True)
    t.start()

    wsock.settimeout(1.0)
    while not stop_loop:

        try:
            data, addr = wsock.recvfrom(1024)
            print(f">>{data} {addr}", flush=True)
            if isinstance(data, bytes):
                if data.startswith(b'@'):
                    known[data[1:].decode()] = time.time()
                else:
                    tasks[data] = [None, []]
            print(tasks, flush=True)
            print(known, flush=True)
        except socket.timeout:
            continue

    print(f'Stop UDP broadcast proxy {os.getpid()}', flush=True)
