import random
import time
from django.conf import settings
import hashlib
import base64
import string
ALLOW_STRS = string.digits + string.ascii_uppercase + string.ascii_lowercase
ALLOW_STRS_LEN = len(ALLOW_STRS)
dc_alphabet = {ALLOW_STRS[j]: j*2 for j in range(0, ALLOW_STRS_LEN)}

def nc_gen_rnd_token():
    letters = [random.choice(ALLOW_STRS) for i in range(14)]
    t = int(time.time() * 1000000)
    for j in range(0, 10):
        letters.append(ALLOW_STRS[t % ALLOW_STRS_LEN])
        t = t // ALLOW_STRS_LEN
    letters += [random.choice(ALLOW_STRS) for i in range(15)]
    nice_chat_client_id = ''.join(letters)
    nice_chat_client_id += make_crc(nice_chat_client_id)
    return nice_chat_client_id


def make_crc(instr):
    if isinstance(instr, str) and len(instr) > 38:
        b1 = 251
        b2 = 52
        for j in instr:
            b1 ^= dc_alphabet.get(j, 0)
            b2 ^= b1
        return ALLOW_STRS[b1 % ALLOW_STRS_LEN] + ALLOW_STRS[b2 % ALLOW_STRS_LEN]
    return ''


def check_crc(instr):
    return True \
        if isinstance(instr, str) and \
           len(instr) > 38 and \
           (make_crc(instr[:-2]) == instr[-2:] or make_crc(b64pad(instr[:-2])) == instr[-2:]) else False


def b64pad(instr):
    return instr + ''.join(['=' for j in range(4-len(instr) % 4)])


def nc_gen_token(account_id, time_shift=0):
    t = int(time.time() / 3600 / 12) + time_shift
    b = '%s-%s-%s' % (account_id, t, settings.WIDGET_SESSION_TOKEN_KEY)
    k = base64.b64encode(hashlib.sha256(b).digest(), '-_').strip('=')
    return k + make_crc(k)


def nc_validate_2key(instr):
    if settings.WIDGET_SESSION_TOKEN_KEY and instr:
        if not isinstance(instr, str):
            return None
        opts = instr.split('.')
        if len(opts) != 2:
            return None
        if nc_gen_token(opts[0]) == opts[1] or nc_gen_token(opts[0], 1) == opts[1] or nc_gen_token(opts[0], 2) == opts[1]:
            return opts[0]
        return None
    else:
        return instr
