from django.utils.translation import gettext_lazy as _


class UserRoles(object):
    SITE_ADMIN = 'admin'
    SITE_AGENT = 'agent'
    COMPANY_OWNER = 'owner'

    CHOICES = (
        (SITE_ADMIN, _('Admin')),
        (SITE_AGENT, _('Agent')),
    )


class WebsocketEventTypes(object):
    BACKEND_SITE_VISITOR_UPDATE = "visitor_set"
    BACKEND_SITE_VISITOR_REMOVE = "visitor_rem"
    BACKEND_SITE_CHAT_CREATE = "chat_new"
    BACKEND_SITE_CHAT_UPDATE = "chat_edt"
    BACKEND_SITE_CHAT_REMOVE = "chat_rem"
    BACKEND_SITE_CHAT_UNREAD = "chat_unread"
    BACKEND_SITE_OPERATOR_UPDATE = "operator_set"
    BACKEND_SITE_CLIENT_UPDATE = "client_set"
    BACKEND_SITE_STATUS_UPDATE = "status_set"

    BACKEND_SITE_SEND_NOTIFY = "notify"

    BACKEND_SITE_VISITOR_LIST = "visitor_list"
    BACKEND_SITE_CHAT_LIST = "chat_list"
    BACKEND_SITE_OPERATOR_LIST = "operator_list"

    BACKEND_SITE_SERVER_NOTIFY = 'srv_notify'
    BACKEND_SITE_MSG_NOTIFY = "msg_notify"
    BACKEND_SITE_START_TYPING = 'start_typing'
    BACKEND_SITE_STOP_TYPING = 'stop_typing'
    BACKEND_SITE_V_MONITOR = 'visitor_mon'

    BACKEND_SITE_SET_OPERATOR_STATE = 'set_state'

    BACKEND_CHAT_ROOM_NEW_MESSAGE = "new_message"
    BACKEND_CHAT_ROOM_UPD_MESSAGE = "upd_message"

    BACKEND_SITE_WS_CALL_START = 'w_call_start'
    BACKEND_SITE_WS_CALL_ROOM = 'w_call_room'
    BACKEND_SITE_WS_CALL_STOP = 'w_call_stop'
    BACKEND_SITE_WS_CALL_PING = 'w_call_ping'

    BACKEND_CHAT_AI_PRESET = 'aipreset'
    BACKEND_CHAT_AI_AGENT = 'aiagent'

    FRONTEND_CHAT_CREATED = 'chat_new'
    FRONTEND_CHAT_NONE = 'no_open_chat'
    FRONTEND_CHAT_CLOSED = 'chat_close'
    FRONTEND_CHAT_ARCHIVED = 'chat_rem'
    FRONTEND_CHAT_SET_DELIVERED = 'set_delivered'
    FRONTEND_CHAT_ID_UPDATE = 'chat_set_id'

    FRONTEND_CHAT_SHOW_WINDOW = 'w_show'
    FRONTEND_CHAT_HIDE_WINDOW = 'w_hide'
    FRONTEND_CHAT_SET_INFO = 'w_info'
    FRONTEND_CHAT_WS_MONITOR = 'w_mon'
    FRONTEND_CHAT_WS_AUTO_INIT = 'autoopen'
    FRONTEND_CHAT_WS_CLIOPEN = 'cliopen'
    FRONTEND_CHAT_WS_CART = 'w_cart'
    FRONTEND_CHAT_WS_GOODS = 'w_get_goods'
    FRONTEND_CHAT_GA_EVENT = 'ga_event'

    FRONTEND_CHAT_CLOSE = 'c_close'
    FRONTEND_CHAT_PUSHFORM = 'c_pushform'
    FRONTEND_CHAT_PURCHASE = 'c_purchase'
    FRONTEND_CHAT_RATE = 'c_rate'
    FRONTEND_CHAT_SET_TYPE = 'c_settype'
    FRONTEND_CHAT_MESSAGE = 'c_message'
    FRONTEND_CHAT_MESSAGES_LIST = 'c_message_list'

    FRONTEND_CHAT_WS_CALL = 'w_call'
    FRONTEND_CHAT_WS_CALL_STOP = 'w_call_s'

    FRONTEND_CHAT_WS_NOTIFY = 'notify'

    FRONTEND_CHAT_WS_GREETEING = 'modal_greet'
    FRONTEND_CHAT_WS_FINAL = 'final_form'
    FRONTEND_CHAT_WS_TYPING_START = 'type_s'
    FRONTEND_CHAT_WS_TYPING_END = 'type_e'
    FRONTEND_CHAT_WS_TYPING_DUMP = 'typing'
    FRONTEND_CHAT_WAS_CLOSED = 'was_closed'

    BOT_LIST_ROOMS = 'bot_rooms'
    BOT_GET_WEBSITE = 'bot_website'
    BOT_SEND_TEXT = 'bot_send_text'
    BOT_SEND_JOINED = 'bot_send_joined'
    BOT_SEND_LEAVE = 'bot_send_leave'
    BOT_GET_ROOM = 'bot_get_room'
    BOT_ON_MESSAGE = 'bot_message'
    BOT_ON_NEWROOM = 'bot_new_room'
    BOT_ON_EDTROOM = 'bot_edit_room'
    BOT_ON_ENDROOM = 'bot_end_room'
    BOT_SEND_TECH = 'bot_send_tech'
    BOT_SEND_FORM = 'bot_send_form'
    BOT_LIST_FORMS = 'bot_list_forms'

    CH_NEW_ROOM = 'new_room'
    CH_RCVD_MSG = 'rcvd_msg'
    CH_CLOSE_ROOM = 'close_room'
    CH_COMMIT = 'msg_commit'
    CH_ON_SEND_MESSAGE = 'on_msg'
    CH_ON_SEND_AGENT_JOIN= 'on_msg_join'
    CH_ON_SEND_AGENT_LEAVE = 'on_msg_leave'
    CH_ON_SEND_SUGGESTION = 'on_msg_product'
