from apps.website.models import Form, FormRow


PURCHASE_FORM = {
    'label': 'Purchase form',
    'mode': Form.MODE_SITE_PURCHASE_FORM,
    'rows': [
        {
            'label': 'Product',
            'kind': FormRow.FIELD_TYPE_GROUP,
            'is_required': False,
            'protected': True,
            'order_num': 0,
            'params': '{"display": "product"}'
        },
        {
            'label': 'ProductId',
            'kind': FormRow.FIELD_TYPE_HIDDEN,
            'is_required': False,
            'protected': True,
            'order_num': 1,
            'params': '{"auto-fill-tag": "PRODUCT_ID"}'
        },
        {
            'label': 'Name',
            'kind': FormRow.FIELD_TYPE_TEXT,
            'protected': True,
            'is_required': True,
            'is_read_only': True,
            'order_num': 2,
            'params': '{"auto-fill-tag": "PRODUCT_NAME"}'
        },
        {
            'label': 'Additional information',
            'kind': FormRow.FIELD_TYPE_TEXTAREA,
            'is_required': False,
            'description': "Properties of the product important for you (like sizes, materials, colors and other)",
            'order_num': 3,
            'params': '{}'
        },
        {
            'label': 'Contact',
            'kind': FormRow.FIELD_TYPE_GROUP,
            'is_required': False,
            'order_num': 5,
            'params': '{}'
        },
        {
            'label': 'Name',
            'kind': FormRow.FIELD_TYPE_TEXT,
            'is_required': True,
            'order_num': 6,
            'params': '{"mode": "text", "display": "text", "placeholder": "Your Name"}'
        },
        {
            'label': 'Phone',
            'kind': FormRow.FIELD_TYPE_TEXT,
            'is_required': False,
            'order_num': 7,
            'params': '{"mode": "text", "placeholder": "Your Phone", "display": "phone"}'
        },
        {
            'label': 'Email',
            'kind': FormRow.FIELD_TYPE_EMAIL,
            'protected': True,
            'is_required': True,
            'order_num': 8,
            'params': '{"mode": "email", "display": "email", "placeholder": "Your email"}'
        },
        {
            'label': 'Shipping Address',
            'kind': FormRow.FIELD_TYPE_ADDRESS,
            'is_required': False,
            'order_num': 10,
            'params': '{"default": {"city": ["", "City"], "country": ["", "Country"], "post": ["", "POST/ZIP"], ' +
                      '"state": ["", "State"]},"notShow": {"first": [false, "First Name"], ' +
                      '"last": [false, "Last Name"], "city": [false, "City"], "country": [false, "Country"], ' +
                      '"post": [false, "POST/ZIP"], "state": [false, "State"]} }'
        },
        {
            'label': 'Billing Address',
            'kind': FormRow.FIELD_TYPE_ADDRESS,
            'is_required': False,
            'order_num': 15,
            'params': '{"default": {"city": ["", "City"], "country": ["", "Country"], "post": ["", "POST/ZIP"], ' +
                      '"state": ["", "State"]},"notShow": {"first": [false, "First Name"], ' +
                      '"last": [false, "Last Name"], "city": [false, "City"], "country": [false, "Country"], ' +
                      '"post": [false, "POST/ZIP"], "state": [false, "State"]} }'
        }
    ]
}
CATCH_FORM = {
    'label': 'LEAD_CATCH_FORM_TRANS',
    'mode': Form.MODE_SITE_CATCH_FORM,
    'rows': [
        {
            'label': 'LABEL_TRANS',
            'kind': FormRow.FIELD_TYPE_LABEL,
            'is_required': False,
            'order_num': 1,
            'params': '{"text": "LEAVE_CONTACTS_TRANS"}'
        },
        {
            'label': 'NAME_TRANS',
            'kind': FormRow.FIELD_TYPE_TEXT,
            'is_required': True,
            'order_num': 2,
            'params': '{"mode": "text", "tag": "PRIMARY_NAME", "display": "text", "placeholder": "YOUR_NAME_TRANS"}'
        },
        {
            'label': 'Email',
            'kind': FormRow.FIELD_TYPE_EMAIL,
            'protected': True,
            'is_required': True,
            'order_num': 3,
            'params': '{"mode": "email", "tag": "PRIMARY_EMAIL", "display": "email", "placeholder": "YOUR_EMAIL_TRANS"}'
        },
    ]
}

GREET_FORM = {
    'label': 'GREETING_FORM_TRANS',
    'mode': Form.MODE_SITE_GREET_FORM,
    'rows': [
        {
            'label': 'LABEL_GREET_TRANS',
            'kind': FormRow.FIELD_TYPE_LABEL,
            'is_required': False,
            'order_num': 1,
            'params': '{"text": "LEAVE_CONTACTS_GREET_TRANS"}'
        },
        {
            'label': 'NAME_GREET_TRANS',
            'kind': FormRow.FIELD_TYPE_TEXT,
            'protected': True,
            'is_required': True,
            'order_num': 2,
            'params': '{"mode": "text", "tag": "PRIMARY_NAME", "display": "text", "default": "Guest", "placeholder": "YOUR_NAME_TRANS"}'
        },
        {
            'label': 'Email',
            'kind': FormRow.FIELD_TYPE_EMAIL,
            'is_required': False,
            'order_num': 3,
            'params': '{"mode": "email", "tag": "PRIMARY_EMAIL", "display": "email", "placeholder": "YOUR_EMAIL_TRANS"}'
        },
        {
            'label': 'OTHER_GREET_TRANS',
            'kind': FormRow.FIELD_TYPE_TEXT,
            'is_required': False,
            'order_num': 4,
            'params': '{"mode": "text", "display": "text", "placeholder": "YOUR_OTHER_TRANS"}'
        },
    ]
}

FINAL_FORM = {
    'label': 'FINAL_FORM_TRANS',
    'mode': Form.MODE_SITE_FINAL_FORM,
    'rows': [
        {
            'label': 'LABEL_FINAL_TRANS',
            'kind': FormRow.FIELD_TYPE_LABEL,
            'is_required': False,
            'order_num': 1,
            'params': '{"text": "LEAVE_CONTACTS_RATE_TRANS"}'
        },
        {
            'label': 'NAME_RATE_TRANS',
            'kind': FormRow.FIELD_TYPE_RATE_STAR,
            'protected': True,
            'is_required': True,
            'order_num': 2,
            'params': '{"tag": "SCORE"}'
        },
    ]
}

FORMS_TEMPLATES = [PURCHASE_FORM, CATCH_FORM, GREET_FORM, FINAL_FORM]
