from rest_framework.permissions import BasePermission


class IsCompanyOwner(BasePermission):
    def has_permission(self, request, view):
        return request.user and request.user.is_authenticated and request.user.is_company_owner


class IsAdmin(BasePermission):
    def has_permission(self, request, view):
        return request.user and request.user.is_authenticated \
               and request.user.is_site_admin(request.current_site)


class IsCompanyOwnerOrAdmin(BasePermission):
    def has_permission(self, request, view):
        if request.user and request.user.is_authenticated:
            if request.user.is_company_owner:
                return True

            if request.current_site:
                return request.user.is_site_admin(request.current_site)

        return False
