import sys
import os
import multiprocessing as mp


stop_flag = False

workers = {}


def apply_stop():
    global stop_flag
    stop_flag = True
    from apps.ncbot.consumers import ws_bot_q
    from apps.connector.consumers import ws_cnn_q
    from apps.visitors.ws import ws_main_q, ws_msg_q, ws_inq_qs
    ws_msg_q.put_nowait(('stop_all', 'stop_all',))
    ws_main_q.put_nowait(('stop_all', 'stop_all',))
    ws_cnn_q.put_nowait(('stop_all', 'stop_all',))
    ws_bot_q.put_nowait(('stop_all', 'stop_all',))
    for q in ws_inq_qs:
        q.put_nowait(('stop_all', 'stop_all',))

def can_i_run():
    global stop_flag
    return not stop_flag


def event_bc(data, addr):
    global workers
    for q in workers.values():
        if q:
            try:
                q.put_nowait(('event', (data, addr,)))
            except Exception as e:
                sys.stderr.write(f"{e}\n")
                pass


def clear_bc(worker):
    global workers
    if worker in workers:
        del workers[worker]


def add_bc_pre(worker):
    global workers
    q = mp.Queue()
    setattr(worker, 'event_q', q)
    workers[worker] = q


def add_bc_post(worker):
    from apps.visitors.ws import ws_inq_qs
    q = getattr(worker, f'event_q', None)
    if q:
        ws_inq_qs.append(q)
