VIDEO_NAME = 'twilionc'

import hashlib
from twilio.rest import Client
from twilio.jwt.access_token import AccessToken
from twilio.jwt.access_token.grants import VideoGrant
from django.conf import settings


def stop_call(props):
    print(props)
    client = Client(settings.TWILIO_VIDEO_KEY, settings.TWILIO_VIDEO_SECRET)
    room = client.video.rooms(props.roomName).fetch()
    if room:
        room.update(status='completed')

    print(room.unique_name)


def start_call(room_name):
    client = Client(settings.TWILIO_VIDEO_KEY, settings.TWILIO_VIDEO_SECRET)
    room = client.video.rooms.create(unique_name=room_name, type='peer-to-peer')
    print(room.sid)

    return {
        'roomSid': room.sid,
        'roomName': room_name
    }


def get_user_props(room_name, cli_name):

    idt = '%s-%s' % (room_name, cli_name)
    idt = hashlib.sha256(idt).hexdigest()
    print(idt)

    token = AccessToken(settings.TWILIO_VIDEO_ACC,
                        settings.TWILIO_VIDEO_KEY,
                        settings.TWILIO_VIDEO_SECRET,
                        identity=idt)

    video_grant = VideoGrant(room=room_name)
    token.add_grant(video_grant)

    return {
        'roomToken': token.to_jwt()
    }
